Subject: Re: bug#20614: Segmentation fault when building on Power8 Little Endian

From: Petr Hracek <[email-masked]>
Date: Tue, 22 Sep 2015 12:17:10 +0200

I have a question:

would it be possible to remove unexelf.c code and replace them with a
"just map a file with pre-compiled byte code" as advice me a colleagues 
in Red Hat?

It seems that this code is also incompatible with PIE.

Together with our binutils-2.23.52.0.1-54 
(https://bugzilla.redhat.com/show_bug.cgi?id=1247126)
it segfaults each time. Now.
What do you think about it?

Nowadays I have commented out the code mentioned on line
http://git.savannah.gnu.org/cgit/emacs.git/tree/src/unexelf.c?h=emacs-24#n869
and afterwards is fails with

Finding pointers to doc strings...
Finding pointers to doc strings...done
Dumping under the name emacs
/bin/sh: line 7: 15764 Segmentation fault      `/bin/pwd`/temacs --batch --load loadup bootstrap
make[2]: *** [bootstrap-emacs] Error 1
make[2]: Leaving directory `/builddir/build/BUILD/emacs-24.3/build-gtk/src'

Important version of packages:

glibc-2.17-103.el7.ppc64le

gcc-4.8.5-4.el7.ppc64le

binutils-2.23.52.0.1-54.el7.ppc64le

Greetings Petr On 09/16/2015 01:28 PM, Petr Hracek wrote:
> On 07/14/2015 09:52 AM, Petr Hracek wrote:
>> On 07/13/2015 03:16 PM, Andreas Schwab wrote:
>>> Petr Hracek <[email-masked]> writes:
>>>> Does emacs-24.3 support ppc64le? 
>>> https://build.opensuse.org/package/binaries/openSUSE:13.2/emacs?repository=ports 
>>> http://download.opensuse.org/ports/ppc/distribution/13.2/repo/oss/suse/ppc64le/emacs-x11-24.3-17.2.2.ppc64le.rpm 
>>> Andreas. 
>> I have find out that the error message Loading 
>> /home/phracek/rpmbuild/BUILD/emacs-24.3/lisp/tooltip.el (source)... 
>> Finding pointers to doc strings... Finding pointers to doc 
>> strings...done Dumping under the name emacs emacs: Program segment 
>> above .bss in 
>> /home/phracek/rpmbuild/BUILD/emacs-24.3/build-gtk/src/temacs make[2]: 
>> *** [bootstrap-emacs] Error 1 comes from file src/unexelf.c line 860 
>> (emacs-24.3) What this function does? I saw in openSUSE SRPM that 
>> option --with-wide-int is used. In Fedora or RHEL we are not using 
>> it. Options which are used for compiling are: ./configure 
>> --build=powerpc64le-redhat-linux-gnu 
>> --host=powerpc64le-redhat-linux-gnu --program-prefix= 
>> --disable-dependency-tracking --prefix=/usr --exec-prefix=/usr 
>> --bindir=/usr/bin --sbindir=/usr/sbin --sysconfdir=/etc 
>> --datadir=/usr/share --includedir=/usr/include --libdir=/usr/lib64 
>> --libexecdir=/usr/libexec --localstatedir=/var 
>> --sharedstatedir=/var/lib --mandir=/usr/share/man 
>> --infodir=/usr/share/info --with-dbus --with-gif --with-jpeg 
>> --with-png --with-rsvg --with-tiff --with-xft --with-xpm 
>> --with-x-toolkit=gtk3 --with-gpm=no 
>> build_alias=powerpc64le-redhat-linux-gnu 
>> host_alias=powerpc64le-redhat-linux-gnu CFLAGS=-DMAIL_USE_LOCKF -O2 
>> -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions 
>> -fstack-protector-strong --param=ssp-buffer-size=4 
>> -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8 
>> LDFLAGS=-Wl,-z,relro  --no-create --no-recursion 
> Building emacs package on Fedora or even on OpenSuse works fine. But 
> under RHEL-7 still fails. Emacs is build up with full RELRO, though. 
> Version of packages which are used for compilation are: gcc-4.8.3 
> automake-1.13.4 autoconf-2.69 Compilation flags are:
> ./configure --build=ppc64le-redhat-linux-gnu --host=ppc64le-redhat-linux-gnu --program-prefix= --disable-dependency-tracking --prefix=/usr --exec-prefix=/usr --bindir=/usr/bin --sbindir=/usr/sbin --sysconfdir=/etc --datadir=/usr/share --includedir=/usr/include --libdir=/usr/lib64 --libexecdir=/usr/libexec --localstatedir=/var --sharedstatedir=/var/lib --mandir=/usr/share/man --infodir=/usr/share/info --enable-link-time-optimization --with-dbus --with-gif --with-jpeg --with-png --with-rsvg --with-tiff --with-xft --with-xpm --with-x-toolkit=gtk3 --with-gpm=no
> + LDFLAGS=-Wl,-z,relro
> + export LDFLAGS
> + CFLAGS='-DMAIL_USE_LOCKF -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8'
> + export CFLAGS
> + CXXFLAGS='-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8'
> + export CXXFLAGS
> + FFLAGS='-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8 -I/usr/lib64/gfortran/modules'
> + export FFLAGS
> + FCFLAGS='-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8 -I/usr/lib64/gfortran/modules'
> + export FCFLAGS
> + LDFLAGS=-Wl,-z,relro
> + export LDFLAGS
> emacs is SPEC file is compiled so that in %prep section is: - setup - 
> patching some files - ./autogen.sh %build section for emacs-gtk: - 
> ./configure is called. - make bootstrap - make %build section for 
> emacs-nox is: - ./configure is called. - make Is this correct? 
> Compilator has settings like:
> CC='gcc -std=gnu99' CFLAGS='-DMAIL_USE_LOCKF -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8 -flto=32' CPPFLAGS='' \
>    LDFLAGS='-Wl,-z,relro -Wl,-znocombreloc ' MAKE='make'
> gcc -std=gnu99 -DHAVE_CONFIG_H -I. -I/builddir/build/BUILD/emacs-24.3/lib -I../src -I/builddir/build/BUILD/emacs-24.3/src      -DMAIL_USE_LOCKF -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8 -flto=32 -c /builddir/build/BUILD/emacs-24.3/lib/allocator.c
> linker has a settings like:
> gcc -std=gnu99     -I. -I../src -I../lib -I/builddir/build/BUILD/emacs-24.3/lib-src -I/builddir/build/BUILD/emacs-24.3/lib-src/../src -I/builddir/build/BUILD/emacs-24.3/lib-src/../lib  -Wl,-z,relro -Wl,-znocombreloc   -DMAIL_USE_LOCKF -O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -fstack-protector-strong --param=ssp-buffer-size=4 -grecord-gcc-switches   -m64 -mcpu=power7 -mtune=power8 -flto=32 -DEMACS_NAME="\"GNU Emacs\"" \
>    -DVERSION="\"24.3\"" /builddir/build/BUILD/emacs-24.3/lib-src/etags.c \
>    regex.o ../lib/libgnu.a  -o etags
>
> Before segmentation fault build log is:
> if test "no" = "yes"; then \
>    rm -f bootstrap-emacs; \
>    ln temacs bootstrap-emacs; \
> else \
>    `/bin/pwd`/temacs --batch --load loadup bootstrap || exit 1; \
>    test "X" = X ||  -zex emacs; \
>    mv -f emacs bootstrap-emacs; \
> fi
> Loading loadup.el (source)...
> Using load-path (/builddir/build/BUILD/emacs-24.3/lisp /builddir/build/BUILD/emacs-24.3/lisp/emacs-lisp /builddir/build/BUILD/emacs-24.3/lisp/language /builddir/build/BUILD/emacs-24.3/lisp/international /builddir/build/BUILD/emacs-24.3/lisp/textmodes)
> Loading emacs-lisp/byte-run (source)...
> Loading emacs-lisp/backquote (source)...
> [ .. snip ...]dir/build/BUILD/emacs-24.3/lisp/vc/vc-hooks.el (source)...
> Loading /builddir/build/BUILD/emacs-24.3/lisp/vc/ediff-hook.el (source)...
> Loading /builddir/build/BUILD/emacs-24.3/lisp/tooltip.el (source)...
> Finding pointers to doc strings...
> Finding pointers to doc strings...done
> Dumping under the name emacs
> emacs: Program segment above .bss in /builddir/build/BUILD/emacs-24.3/build-gtk/src/temacs
> make[2]: *** [bootstrap-emacs] Error 1
> make[2]: Leaving directory `/builddir/build/BUILD/emacs-24.3/build-gtk/src'
> make[1]: *** [src] Error 2
> Part of code which is relevant is from src/unexelf.c:   for (n = 
> new_file_h->e_phnum; --n >= 0; )     {       /* Compute maximum of all 
> requirements for alignment of section.  */       ElfW (Word) alignment 
> = (NEW_PROGRAM_H (n)).p_align;       if ((OLD_SECTION_H 
> (old_bss_index)).sh_addralign > alignment)     alignment = 
> OLD_SECTION_H (old_bss_index).sh_addralign; #ifdef __sgi       /* 
> According to [email-masked] (Karsten Kuenne)          and 
> [email-masked] (Alexandre Oliva), on IRIX 5.2, we          always get 
> "Program segment above .bss" when dumping          when the executable 
> doesn't have an sbss section.  */       if (old_sbss_index != -1) 
> #endif /* __sgi */       if (NEW_PROGRAM_H (n).p_vaddr + NEW_PROGRAM_H 
> (n).p_filesz       > (old_sbss_index == -1          ? old_bss_addr     
>      : round_up (old_bss_addr, alignment))) *fatal ("Program segment 
> above .bss in %s", old_name);*       if (NEW_PROGRAM_H (n).p_type == 
> PT_LOAD If I understand there shouldn't be a problem on ppc64le. But I 
> don't understand a code at all.
> -- 
> Petr Hracek
> Software Engineer
> Developer Experience
> Red Hat, Inc
> Mob: +420777056169
> email:[email-masked]
-- 
Petr Hracek
Software Engineer
Developer Experience
Red Hat, Inc
Mob: +420777056169
email: [email-masked]